<script>
	import { isLight } from "@/stores/static"

	export let active = true
</script>

<template lang="pug">
	#loading( class:is-disabled='{!active}' class:dark='{!$isLight}' )
		.vertical-centered-box
			.content
				.loader-circle
				.loader-line-mask
					.loader-line
</template>

<style lang="scss">
	@keyframes rotate{ 0% {-webkit-transform: rotate(0deg);-moz-transform: rotate(0deg);-ms-transform: rotate(0deg);transform: rotate(0deg);} 100% {-webkit-transform: rotate(-360deg);-moz-transform: rotate(-360deg);-ms-transform: rotate(-360deg);transform: rotate(-360deg);}}

	#loading * {
		-webkit-transition: all 1s;
		-moz-transition: all 1s;
		-o-transition: all 1s;
		transition: all 1s;
		dir: ltr !important;
	}
	#loading {
		position: absolute;
		left: 0;
		right: 0;
		top: 0;
		bottom: 0;
		z-index: 9;
		background: rgba($white, .7);
		transition: 
			bottom .1s ease-in-out,
			top .1s ease-in-out,
			opacity .1s ease-in-out,
			background .1s ease-in-out;
		overflow: hidden;
		&.is-disabled {
			// top: -100%;
			bottom: 100%;
			opacity: 0;
		}
		&.dark {
			background: rgba(27, 26, 26, 0.7);
			.loader-line-mask {
				-webkit-mask-image: -webkit-linear-gradient(top, $white, rgba(255, 255, 255, 0));
				.loader-line {
					box-shadow: inset 0 0 0 1px rgba($white, .75);
				}
			}
		}
	}

	.loader-circle,
	.loader-line-mask {
		height: 120px;
		margin-left: -60px;
		margin-top: -60px;
		position: absolute;
		left: 50%;
		top: 9rem;
	}

	.loader-circle {
		width: 120px;
		border-radius: 50%;
		box-shadow: inset 0 0 0 1px transparent;
	}
	.loader-line-mask {
		width: 60px;
		overflow: hidden;
		-webkit-transform-origin: 60px 60px;
		-moz-transform-origin: 60px 60px;
		-ms-transform-origin: 60px 60px;
		-o-transform-origin: 60px 60px;
		transform-origin: 60px 60px;
		-webkit-mask-image: -webkit-linear-gradient(top, #000000, rgba(0, 0, 0, 0));
		-webkit-animation: rotate reverse 1.2s infinite linear;
		-moz-animation: rotate reverse 1.2s infinite linear;
		-o-animation: rotate reverse 1.2s infinite linear;
		animation: rotate reverse 1.2s infinite linear;
	}
	.loader-line-mask .loader-line {
		width: 120px;
		height: 120px;
		border-radius: 50%;
		box-shadow: inset 0 0 0 1px rgba($black, .75);
	}
</style>